#include "Loader.h"
#include "Tribes.h"
#include "Endframe.h"
#include "PlayGUI.h"
#include "Patch.h"
#include "mem.ver"

/*
	Plugins
*/
#include "Plugin_ClientGetPing.h"
#include "Plugin_Winamp.h"
#include "Plugin_Trilinear.h"

#include "Endframe_Player.h"
#include "Endframe_Screensize.h"
#include "Endframe_SkyRotation.h"

//0062F794  0050D354  <Tribes.Game::EndFrame>
//00624038  004AB500  <Tribes.Reticle & Indicators::OnDraw>


void *__game_endframe_jmp = (void *)0x0050D354,
     *__playgui_ondraw_jmp = (void *)0x004AB500;

int __loader_started = 0;

void loader_init( ) {
	__asm {		
		lea eax, loader_endframe
		mov ds:[ 0x62f794 ], eax // game::endframe

		lea eax, loader_playgui_ondraw
		mov ds:[ 0x624038 ], eax

		mov ds:[ PTR_MEMDLL_NOTLOADED ], 1
	}
}

__naked void loader_endframe( ) {
	__asm {
		pushad

		cmp [__loader_started], 1
		je __loader_skipstartup
		
		call loader_startup
		mov [__loader_started], 1

__loader_skipstartup:
		call game_endframe

		popad

		jmp __game_endframe_jmp
	}
}

__naked void loader_playgui_ondraw( ) {
	__asm {
		pushad
		push edx
		call playgui_ondraw
		pop edx
		popad

		jmp __playgui_ondraw_jmp
	}
}


//FN_STUB( Tribes_Test, Tribes::Test )
FN_STUB( ClientGetPingStub, Client_GetPing )
FN_STUB( Winamp_Command, Winamp::Command );
FN_STUB( Winamp_Active, Winamp::Active );

void loader_startup( ) {
	Tribes::Echo( "mem.dll v%d.%02d(%d) loaded", MEM_VERSION_MAJOR, MEM_VERSION_MIN, BUILD_NUM );

	//Tribes::RegisterFunction( "Tribes::Test", Tribes_Test );

	// Plugins
	Tribes::RegisterFunction( "Client::GetPing", ClientGetPingStub );
	Tribes::RegisterFunction( "Winamp::Command", Winamp_Command );
	Tribes::RegisterFunction( "Winamp::Active", Winamp_Active );

	Trilinear_Load( );

	Endframe_Player_Load( );
	Endframe_Screensize_Load( );
	Endframe_SkyRotation_Load( );
}