#ifndef __MATH_H__
#define __MATH_H__

#include "Sys.h"
#include "Types.h"

/* 2d Vectors */
void		vectorAdd2f(Vertex2f *a, Vertex2f *b, Vertex2f *c);
void		vectorSub2f(Vertex2f *a, Vertex2f *b, Vertex2f *c);
void		vectorDiv2f(Vertex2f *a, Vertex2f *b, float div);
void		vectorNormalize2f(Vertex2f *a, Vertex2f *b);
float		vectorLength2f(Vertex2f *a);
float		vectorDot2f(Vertex2f *a, Vertex2f *b);
float		vectorCross2f(Vertex2f *a, Vertex2f *b);
float		vectorAngle2f(Vertex2f *a, Vertex2f *b);

/* 3d Vectors  */
void		vectorAdd(Vertex3f *a, Vertex3f *b, Vertex3f *c);
void		vectorSub(Vertex3f *a, Vertex3f *b, Vertex3f *c);
void		vectorMul(Vertex3f *a, Vertex3f *b, float mult);
void		vectorDiv(Vertex3f *a, Vertex3f *b, float div);
float       vectorDot( Vertex3f *a, Vertex3f *b );
void        vectorNormalize( Vertex3f *a, Vertex3f *b );
void        vectorCross( Vertex3f *a, Vertex3f *b, Vertex3f *c );
void        vectorRotate( Vertex3f *a, Vertex3f *b, float pitch, float yaw );
float       vectorLength( Vertex3f *a );
float       vectorLengthSqr( Vertex3f *a );
void        vectorTransform( Vertex3f *mat, Vertex3f *in, Vertex3f *out );
void        vectorTransformAdd( Vertex3f *mat, Vertex3f *in, Vertex3f *out );
void        vectorRotate( Vertex3f *mat, Vertex3f *in, Vertex3f *out );


#endif // __MATH_H__