#include "Tribes.h"
#include "Plugin_Winamp.h"

HWND Winamp::hwnd = NULL;
char *Winamp::states[] = { "Stopped", "Playing", "Not Open", "Paused" };

char *Winamp::Active( int argc, char *argv[] ) {
	return ( Winamp::IsActive( ) ? Tribes::True : Tribes::False );
}


char *Winamp::Command( int argc, char *argv[] ) {
	char *response = Tribes::True;
	bool is_active = Winamp::IsActive( );

	if ( argc <= 0 ) {
		Tribes::Echo( "Winamp::Command( %%cmd );" );
		response = Tribes::False;
	} else {
		char *param = argv[ 0 ];
		int state = ( is_active ) ? SendMessage( Winamp::hwnd, WM_USER, 0, 104 ) : WINAMP_NOTOPEN;

		if ( ( state < 0 ) || ( state > 3 ) )
			state = WINAMP_NOTOPEN;

		is_active = ( is_active && ( state != WINAMP_NOTOPEN ) );

		if ( !Tribes::Stricmp( param, "state" ) ) {
			// state
			response = Winamp::states[ state ];

		} else if ( is_active ) { 
			if ( !Tribes::Stricmp( param, "play" ) ) {
				// play
				if ( state != WINAMP_PLAYING ) {
					PostMessage( Winamp::hwnd, WM_COMMAND, 40045, 0 );
				}

			} else if ( !Tribes::Stricmp( param, "pause" ) ) {
				// pause
				if ( state != WINAMP_PAUSED ) {
					PostMessage( Winamp::hwnd, WM_COMMAND, 40046, 0 );
				}

			} else if ( !Tribes::Stricmp( param, "stop" ) ) {
				// stop
				if ( state != WINAMP_STOPPED ) {
					PostMessage( Winamp::hwnd, WM_COMMAND, 40047, 0 );
				}

			} else if ( !Tribes::Stricmp( param, "next" ) ) {
				//next 
				PostMessage( Winamp::hwnd, WM_COMMAND, 40048, 0 );

			} else if ( !Tribes::Stricmp( param, "prev" ) ) {
				// prev
				PostMessage( Winamp::hwnd, WM_COMMAND, 40044, 0 );

			} else if ( !Tribes::Stricmp( param, "songtitle" ) ) {
				// songtitle
				GetWindowText( Winamp::hwnd, Tribes::sprintBuffer, 256 );
				char *tag = Tribes::Strstr( Tribes::sprintBuffer, " - Winamp" );

				if ( tag ) {
					*tag = 0;
					response = Tribes::sprintBuffer;
				} else {
					response = Winamp::states[ WINAMP_STOPPED ];
				}
			} else {
				// is_active && bad command
				response = Tribes::False;
			}
		} else {
			// !is_active && command != state
			response = Winamp::states[ WINAMP_NOTOPEN ];
		}
	}
	
	return ( response );
}


__noinline bool Winamp::IsActive( ) {
	Winamp::hwnd = FindWindow( "Winamp v1.x", NULL );
	return ( Winamp::hwnd != NULL );
}