#ifndef __SYS_H__
#define __SYS_H__

#include <windows.h>
#include "libc.h"

#define __dllapi    __declspec(dllexport)
#define __naked     __declspec(naked)
#define __noinline  __declspec(noinline)

#define MEM_VERSION_MAJOR 0
#define MEM_VERSION_MIN   4

#define __inline __forceinline

/*
	hm2 legacy
*/
#define PAD_PREFIX()   p
#define PAD( size )    char PAD_PREFIX()__LINE__[ (size) ];
#define PID2           1.570796327f
#define PI             3.141592654f
#define PI2            6.283185307f
#define RAD2DEG(rad)   ((rad)*360.0f/PI2)
#define DEG2RAD(deg)   ((deg)*PI2/360.0f)

/*
	Used to declare stub functions for scripted
	functions
*/

#define FN_STUB( _name, _stub )     \
__naked void _name( ) {             \
	__asm push ebp                  \
	__asm mov ebp, esp              \
	__asm push ebx                  \
	__asm push esi                  \
	__asm mov esi, ss:[ ebp + 0x8 ] \
	__asm add esi, 4                \
	__asm push esi                  \
	__asm dec ecx                   \
	__asm push ecx                  \
	__asm call _stub                \
	__asm add esp, 8                \
	__asm pop esi                   \
	__asm pop ebx                   \
	__asm pop ebp                   \
	__asm retn 4                    \
}

#define FN_STUB_NUDE( _name, _stub )\
__naked void _name( ) {             \
	__asm call _stub                \
	__asm retn 4                    \
}


#endif // __SYS_H__