#ifndef __LIBC_H__
#define __LIBC_H__

#include <math.h>

#define __CUSTOM_LIBC__ 1 // comment this for default libc

#if defined(__CUSTOM_LIBC__)

#pragma comment(linker, "/NODEFAULTLIB") // no default libraries
#pragma comment(linker, "/ENTRY:DllMain") // enter on our dllmain
#pragma comment(linker, "/MERGE:.rdata=.text") // merge sections

/* asin (among others) has no true intrinsic */
#define     asinf( a ) ( fasin( a ) )
float       fasin( float angle );

__inline float fasin( float angle ) {
	return (float )( atan2( angle, sqrt( 1 - angle*angle ) ) );
}


#else // No custom libc


#endif // __STRIPPED_LIBC__



#endif // __LIBC_H__